from enum import Enum
from nmigen import *
from nmigen.hdl.ast import *
from nmigen.hdl.rec import *
from nmigen.asserts import *
from nmigen.cli import main

class DummyPlug(Elaboratable):

    #def __init__(self):



    def elaborate(self, platform):
        m = Module()

        unsliced = Signal(8,reset=0b1111_1111)

        current_slice = Signal(8)
        lower_bits_cut = Signal(8)
        top_cut = Signal(4)

        LS_bit_index = Signal(4,reset=1)
        MS_bit_index = Signal(4,reset=7)
        m.d.sync += MS_bit_index.eq(MS_bit_index-1)

        m.d.comb += lower_bits_cut.eq(unsliced>>LS_bit_index)
        m.d.comb += top_cut.eq(8-MS_bit_index-1+LS_bit_index) #is this correct given there's the lower bit cutting that happens before this? we need to draw it out to be sure
#        m.d.comb += current_slice.eq(((lower_bits_cut<<top_cut)&0xff)>>top_cut)
        m.d.comb += current_slice.eq(Part(unsliced, offset=LS_bit_index, width=MS_bit_index))

        #m.d.comb += shreg_new_bits.eq(MS_bit_index-LS_bit_index+1)

        return m



if __name__ == '__main__':
    baka =DummyPlug()
    main(baka)
    #platform.build(DummyPlug())
